message("FindOpenBLAS starting...")

FIND_PATH(
    OpenBLAS_INCLUDE_DIR

    NAMES
        cblas.h

    HINTS
        ${OpenBLAS_INCLUDE_DIRECTORY}
        $ENV{OpenBLAS_INCLUDE_DIRECTORY}
        ${ROOT_DIR}/external_dependencies/OpenBLAS
        /usr

    PATH_SUFFIXES
        include
        include/x86_64-linux-gnu
        include/OpenBLAS
)

FIND_LIBRARY(
        OpenBLAS_LIBRARIES

        NAMES
        openblas

        HINTS
        ${OpenBLAS_LIBRARY_DIRECTORY}
        $ENV{OpenBLAS_LIBRARY_DIRECTORY}
        ${ROOT_DIR}/external_dependencies/OpenBLAS/
#        ${ROOT_DIR}/external_dependencies/OpenBLAS/lib
        /usr

        PATH_SUFFIXES
        lib
        lib/x86_64-linux-gnu
        local
        include/OpenBLAS/lib
)

# Set OpenBLAS_Found
INCLUDE(FindPackageHandleStandardArgs)
FIND_PACKAGE_HANDLE_STANDARD_ARGS(
        OpenBLAS

        FAIL_MESSAGE
        "OpenBLAS was NOT found!"

        REQUIRED_VARS
        OpenBLAS_INCLUDE_DIR
        OpenBLAS_LIBRARIES
)

IF (OpenBLAS_FOUND)
   MESSAGE(STATUS "OpenBLAS was found.")
   MESSAGE(STATUS "OpenBLAS_LIBRARIES: ${OpenBLAS_LIBRARIES}")
   MESSAGE(STATUS "OpenBLAS_INCLUDE_DIR: ${OpenBLAS_INCLUDE_DIR}")
ELSE()
    MESSAGE(STATUS "Could not find OpenBLAS")
ENDIF()
