/**
 * DESCRIPTION OF THE FILE
 *
 * @author Michal Kravčenko
 * @date 15.3.19 -
 */

#include "NeuronBiased.h"
#include "NeuronConstant.h"

namespace lib4neuro{

    NeuronBiased::NeuronBiased(double b) {
        this->bias = b;
    }

    double NeuronBiased::activate(double x, double b) {
        return x + this->bias;
    }

    double NeuronBiased::activation_function_eval_derivative(double x, double b) {
        return 1.0;
    }

    double NeuronBiased::activation_function_eval_derivative_bias(double x, double b) {
        return 0.0;
    }

    Neuron* NeuronBiased::get_derivative() {
        NeuronConstant *output = new NeuronConstant(1.0);
        return output;
    }

}//end of namespace lib4neuro